'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _d2LibCheck = require('d2/lib/check');

var _d2LibUtils = require('d2/lib/utils');

var _d2ExternalJquery = require('d2/external/jquery');

var _d2ExternalJquery2 = _interopRequireDefault(_d2ExternalJquery);

var Api = (function () {
    function Api(jquery) {
        _classCallCheck(this, Api);

        this.jquery = jquery;
        this.baseUrl = '/api';
        this.defaultRequestSettings = {
            data: {},
            contentType: 'application/json',
            type: undefined,
            url: undefined
        };
    }

    _createClass(Api, [{
        key: 'get',
        value: function get(url, data, options) {
            return this.request('GET', getUrl(this.baseUrl, url), data, options);
        }
    }, {
        key: 'post',
        value: function post(url, data) {
            return this.request('POST', getUrl(this.baseUrl, url), JSON.stringify(data));
        }
    }, {
        key: 'remove',
        value: function remove() {}
    }, {
        key: 'update',

        //TODO: write tests for update
        value: function update(url, data) {
            return this.request('PUT', url, JSON.stringify(data));
        }
    }, {
        key: 'request',
        value: function request(type, url, data) {
            var options = arguments[3] === undefined ? {} : arguments[3];

            (0, _d2LibCheck.checkType)(type, 'string', 'Request type');
            (0, _d2LibCheck.checkType)(url, 'string', 'Url');

            if (data && data.filter) {
                var theRealFilter = data.filter.reduce(function (current, filter) {
                    return current + '&filter=' + filter;
                }, '');
                delete data.filter;
                url += '?' + theRealFilter;
            }

            var api = this;

            return new Promise(function (resolve, reject) {
                api.jquery.ajax(getOptions({
                    type: type,
                    url: url,
                    data: data || {},
                    dataType: options.dataType || 'json'
                })).then(processSuccess(resolve), processFailure(reject));
            });

            function getOptions(mergeOptions) {
                var options = {};

                (0, _d2LibUtils.copyOwnProperties)(options, api.defaultRequestSettings);
                (0, _d2LibUtils.copyOwnProperties)(options, mergeOptions);

                return options;
            }
        }
    }, {
        key: 'setBaseUrl',
        value: function setBaseUrl(baseUrl) {
            (0, _d2LibCheck.checkType)(baseUrl, 'string', 'Base url');

            this.baseUrl = baseUrl;

            return this;
        }
    }]);

    return Api;
})();

Api.getApi = getApi;
function getApi() {
    if (getApi.api) {
        return getApi.api;
    }
    return getApi.api = new Api(_d2ExternalJquery2['default']);
}

function processSuccess(resolve) {
    return function (data /*, textStatus, jqXHR*/) {
        resolve(data);
    };
}

function processFailure(reject) {
    return function (jqXHR /*, textStatus, errorThrown*/) {
        delete jqXHR.then;
        reject(jqXHR);
    };
}

function getUrl(baseUrl, url) {
    //If we are dealing with an absolute url use that instead
    if (new RegExp('^(:?https?:)?//').test(url)) {
        return url;
    }

    var urlParts = [];

    if (baseUrl) {
        urlParts.push(baseUrl);
    }
    urlParts.push(url);

    return urlParts.join('/').replace(new RegExp('(.(?:[^:]))//+', 'g'), '$1/').replace(new RegExp('/$'), '');
}

exports['default'] = Api;
module.exports = exports['default'];