/* global global */
'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _d2LibCheck = require('d2/lib/check');

var console;

var Logger = (function () {
    function Logger(logging) {
        _classCallCheck(this, Logger);

        (0, _d2LibCheck.checkType)(logging, 'object', 'console');
        console = logging;
    }

    _createClass(Logger, [{
        key: 'canLog',
        value: function canLog(type) {
            return !!(type && console && (0, _d2LibCheck.isType)(console[type], 'function'));
        }
    }, {
        key: 'debug',
        value: function debug() {
            for (var _len = arguments.length, rest = Array(_len), _key = 0; _key < _len; _key++) {
                rest[_key] = arguments[_key];
            }

            if (this.canLog('debug')) {
                console.debug.apply(console, rest);
                return true;
            }
            return false;
        }
    }, {
        key: 'error',
        value: function error() {
            for (var _len2 = arguments.length, rest = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                rest[_key2] = arguments[_key2];
            }

            if (this.canLog('error')) {
                console.log(arguments);
                console.error.apply(console, rest);
                return true;
            }
            return false;
        }
    }, {
        key: 'log',
        value: function log() {
            for (var _len3 = arguments.length, rest = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
                rest[_key3] = arguments[_key3];
            }

            if (this.canLog('log')) {
                console.log.apply(console, rest);
                return true;
            }
            return false;
        }
    }, {
        key: 'warn',
        value: function warn() {
            for (var _len4 = arguments.length, rest = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
                rest[_key4] = arguments[_key4];
            }

            if (this.canLog('warn')) {
                console.warn.apply(console, rest);
                return true;
            }
            return false;
        }
    }]);

    return Logger;
})();

Logger.getLogger = function () {
    var console;

    //TODO: This is not very clean try to figure out a better way to do this.
    try {
        //Node version
        console = global.console;
    } catch (e) {
        //Browser version fallback
        console = window.console;
    }

    if (this.logger) {
        return this.logger;
    }
    return this.logger = new Logger(console);
};

exports['default'] = Logger;
module.exports = exports['default'];