'use strict';
Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

/**
 * @module System
 *
 * @requires d2/system/SystemSettings
 */

var _d2SystemSystemSettings = require('d2/system/SystemSettings');

var _d2SystemSystemSettings2 = _interopRequireDefault(_d2SystemSystemSettings);

/**
 * @class System
 *
 * @description
 * Represents the system that can be interacted with. There is a single instance of this pre-defined onto the d2
 * object after initialisation. This can be interacted with using its property objects to among other be used
 * to get and save systemSettings.
 */

var System = (function () {
  function System(settings) {
    _classCallCheck(this, System);

    /**
     * @property {SystemSettings} settings Contains a reference to a `SystemSettings` instance that can be used
     * to retrieve and save system settings.
     *
     * @description
     * ```js
     * d2.system.settings.get('keyLastSuccessfulResourceTablesUpdate')
     *  .then(systemSettingsValue => {
     *    console.log('Analytics was last updated on: ' + systemSettingsValue);
     *  });
     * ```
     */
    this.settings = settings;
  }

  _createClass(System, null, [{
    key: 'getSystem',

    /**
     * @method getSystem
     * @static
     *
     * @returns {System} Object with the system interaction properties
     *
     * @description
     * Get a new instance of the system object.
     */
    value: function getSystem() {
      return new System(new _d2SystemSystemSettings2['default']());
    }
  }]);

  return System;
})();

exports['default'] = System;
module.exports = exports['default'];